package nl.wimvanhaaren.securewicket.web;

import nl.wimvanhaaren.securewicket.services.HelloWorldService;
import nl.wimvanhaaren.securewicket.web.admin.AdminPage;

import org.apache.wicket.Page;
import org.apache.wicket.request.mapper.parameter.PageParameters;
import org.apache.wicket.spring.injection.annot.SpringBean;
import org.apache.wicket.markup.html.basic.Label;
import org.apache.wicket.markup.html.link.Link;
import org.apache.wicket.markup.html.WebPage;

public class HomePage extends WebPage {

    private static final long serialVersionUID = 1L;
    
    @SpringBean
    private HelloWorldService helloWorldService;

    public HomePage(final PageParameters parameters) {
	add(new Label("msg", helloWorldService.sayHello()));
	
	add(new Link("linkToUserPage"){
	    @Override
	    public void onClick() {
		Page next = new UserPage();
		setResponsePage(next);
	    }
	});

	add(new Link("linkToAdminPage"){
	    @Override
	    public void onClick() {
		Page next = new AdminPage();
		setResponsePage(next);
	    }
	});
	
	add(new Label("version", getApplication().getFrameworkSettings().getVersion()));
	// TODO Add your page's components here
    }

}
